#!/sbin/sh
# Script installer for Sibere's Data2SD
# Sibere's Data2SD code. Revised on Feb 10, 2011
# Flashable zip by Droidzone

SetData2SDInfo () {
echo $dsdtxt > $dsdfile
/system/xbin/busybox sed -i -e 's/\('"ro.build.description"'=\).*$/\1'"$dsdtxt"'/g' $aboutfile
}
dsdcode="X12E"
dsdtxt="GingerBurst Data2SD $dsdcode Droidzone"
dsdfile="/sd/data2sd.prop"
aboutfile="/system/build.prop"
#
mount /system
mount /data
mount /sdcard
:> /system/etc/mtab
cd /
#Creating an ext4 filesystem
/system/bin/mke2fs -T ext4 -b 4096 -E stride=64,stripe-width=64 -O extent,^huge_file -m 0 -L userdata /dev/block/mmcblk0p2
/system/xbin/busybox mkdir /sd
#Creating log folders
/system/xbin/busybox mkdir /cache
/system/xbin/busybox mkdir /cache/log
/system/xbin/busybox chmod 660  /cache/log
# create permanent mount point for mtdblock5 on /system/data/
/system/xbin/busybox mkdir /system/data/
/system/xbin/busybox chown 1000.1000 /system/data/
/system/xbin/busybox chmod 0771 /system/data/
/system/xbin/busybox mount -t ext4 -o noatime,nodiratime,nosuid,nodev,nobh,nouser_xattr,noauto_da_alloc /dev/block/mmcblk0p2 /sd
cd /data
# move all NAND to SD
/system/xbin/busybox cp -a * /sd
cd /sd
sync
# moving dalvik-cache, system, propery and misc back to nand
/system/xbin/busybox cp -a /sd/system/* /data/system/
/system/xbin/busybox cp -a /sd/property/* /data/property/
/system/xbin/busybox cp -a /sd/misc/* /data/misc/
# deleting directories before creating links
/system/xbin/busybox rm -r /sd/system
/system/xbin/busybox rm -r /sd/misc
/system/xbin/busybox rm -r /sd/property
/system/xbin/busybox ln -s /system/data/system/ system
/system/xbin/busybox ln -s /system/data/misc/ misc
/system/xbin/busybox ln -s /system/data/property/ property
sync
cd /
SetData2SDInfo;
# Data2sd version information
echo "Data2sd version:X1" > /sd/data2sd.prop

/system/xbin/busybox umount /sd
# Running patcher for mount problems in Linux & Mac
/system/xbin/busybox sed -i 's/dev_mount sdcard \/mnt\/sdcard auto /dev_mount sdcard \/mnt\/sdcard 1 /' /system/etc/vold.fstab